<template>
  <div ref="container" class="sa-table" data-testid="table" @scroll="onScroll">
    <table ref="table">
      <thead ref="tableHeader">
        <tr v-for="(headers, i) in headerRows" :key="i">
          <th
            v-for="header in headers"
            :key="header.id"
            :data-testid="header.id"
            :rowspan="header.rowSpan"
            :colspan="header.colSpan"
            :class="header.className"
            class="label"
            :style="{ minWidth: headerWidths[header.id] + 'px' }"
          >
            {{ header.title }}
          </th>
        </tr>
      </thead>
      <tbody>
        <tr v-if="meta && meta.total_filtered_results === 0">
          <td :colspan="flatColumns.length" class="table-status">
            No data found
          </td>
        </tr>
        <tr
          v-if="showSummaryRow"
          ref="tableSummary"
          data-testid="summary"
          class="summary"
          :class="{ subcolumns: hasSubColumns }"
        >
          <td
            v-for="column in flatColumns"
            :key="column.id"
            :data-testid="column.id"
          >
            <span v-if="column.type === DATATYPES.Disabled">
              <sa-table-cell-disabled />
            </span>

            <span v-else-if="summaryRow[column.id]">
              <sa-table-cell-status-totals
                v-if="summaryRow[column.id].statuses"
                :status-totals="summaryRow[column.id].statuses"
              ></sa-table-cell-status-totals>

              <sa-table-cell-simple
                v-else-if="summaryRow[column.id].total"
                :value="summaryRow[column.id].total"
              ></sa-table-cell-simple>
            </span>
          </td>
        </tr>
        <tr v-if="!rows">
          <td :colspan="flatColumns.length" class="table-status">
            <sa-icon icon="loader" spin /> Loading
          </td>
        </tr>
      </tbody>
      <template v-if="firstRow">
        <sa-table-row-group
          v-if="rootGroup"
          :group="rootGroup"
          :all-rows="rows"
          :columns="flatColumns"
          :cell-type="cellType"
          :cell-props="cellProps"
          :spacer-height="spacerHeight"
        />
        <tbody v-else>
          <sa-table-row
            ref="testRow"
            :style="{ opacity: 0 }"
            :row="firstRow"
            :columns="flatColumns"
            :cell-props="cellProps"
            :cell-type="cellType"
          />
        </tbody>
      </template>
      <tbody
        v-if="
          rootGroup &&
            meta &&
            rootGroup.lastRowIndex < meta.total_filtered_results - 1
        "
      >
        <tr>
          <td :colspan="flatColumns.length" class="table-status extra-rows">
            {{ extraRows }}
          </td>
        </tr>
      </tbody>
    </table>
  </div>
</template>

<script>
import './SaTable.scss'
import { debounce } from 'lodash'
import { DATATYPES, COLUMN_GROUPS } from '../../data/constants'
import { getColumnValue } from '../../data/util'
import tableStore from '../../mixins/tableStore'
import SaTableRow from './rows/SaTableRow'
import SaTableRowGroup from './rows/SaTableRowGroup.js'
import RowGroup from './rows/RowGroup.js'

export default {
  name: 'SaTable',
  components: {
    SaTableRow,
    SaTableRowGroup
  },
  mixins: [tableStore],
  props: {
    /** Control how individual cells are rendered */
    customRenderers: {
      type: Object,
      default: () => ({})
    },
    /** Show summary row when these column groups are displayed */
    showSummaryGroups: {
      type: Array,
      default: () => [COLUMN_GROUPS.Status]
    },
    /** Controls the virtual scrolling implementation. You shouldn't need to change this. */
    minGroupRows: {
      type: Number,
      default: 30
    },
    /** Number of milliseconds to wait after a scroll before loading new table data */
    fetchDebounce: {
      type: Number,
      default: 200
    },
    /** Truncate the table after this many rows */
    maxRows: {
      type: Number,
      default: 50000
    },
    /** Message to show when reaching the end of table if some rows were truncated */
    extraRowsMessage: {
      type: String,
      default: '+:count more rows.'
    }
  },
  data(props) {
    return {
      rootGroup: null,
      spacerHeight: 25, // Used to render a chunk of empty rows
      offsetHeight: 0, // Combined height of thead and summary row
      headerWidths: {},
      slowRequestTimeout: 5000,
      loadNewData_debounced: debounce(
        () => this.loadNewData(),
        props.fetchDebounce
      )
    }
  },
  computed: {
    /**
     * Convert model fields into columns. Gives each column a unique id
     * that can be used to get the right value from each row of data.
     * Normalises DateTime fields into a column with two sub-columns.
     * @returns {*}
     */
    columns() {
      if (!this.model || !this.model.fields) {
        return []
      }

      return this.model.fields.map((field) => {
        const column = {
          id: field.id,
          title: field.title,
          type: field.type
        }
        // when displaying the 'dates' column group, convert the 'event' column into two 'date' columns
        if (
          field.type === DATATYPES.Event &&
          this.columnGroup === COLUMN_GROUPS.Dates
        ) {
          column.subColumns = [
            {
              id: field.started.id,
              title: 'Start Date',
              type: DATATYPES.Date
            },
            {
              id: field.done.id,
              title: 'End Date',
              type: DATATYPES.Date
            }
          ]
        }
        // if there are subfields, and there is no custom renderer, create subcolumns
        if (field.subfields && !this.getCustomRenderer(column.id)) {
          column.subColumns = field.subfields.map((subfield) => ({
            id: subfield.id,
            title: subfield.title,
            type: subfield.type
          }))
        }
        return column
      })
    },
    hasSubColumns() {
      return this.columns.some((column) => 'subColumns' in column)
    },
    /**
     * Return two rows of headers in order to display sub-columns.
     *
     * @returns {*[]}
     */
    headerRows() {
      const mainHeaders = []
      const subHeaders = []
      for (const column of this.columns) {
        if (!column.subColumns) {
          mainHeaders.push({
            id: column.id,
            title: column.title,
            rowSpan: 2
          })
          continue
        }
        mainHeaders.push({
          id: column.id,
          title: column.title,
          rowSpan: 1,
          colSpan: column.subColumns.length,
          className: 'main-header'
        })
        for (const subColumn of column.subColumns) {
          subHeaders.push({
            id: subColumn.id,
            title: subColumn.title,
            className: 'sub-header'
          })
        }
      }

      return [mainHeaders, subHeaders].filter((row) => row.length)
    },
    /**
     * Flatten the columns into a single array, replacing columns with
     * their children if they have them.
     *
     * @returns {[]}
     */
    flatColumns() {
      const flatColumns = []
      for (const column of this.columns) {
        if (!column.subColumns) {
          flatColumns.push(column)
          continue
        }
        for (const subColumn of column.subColumns) {
          flatColumns.push({
            ...subColumn,
            id: subColumn.id
          })
        }
      }
      return flatColumns
    },
    /**
     * Get the state from the injected store that contains the table data.
     */
    tableState() {
      return this.tableStore.state
    },
    rows() {
      return this.tableState.rows
    },
    meta() {
      return this.tableState.meta
    },
    filters() {
      return this.tableState.filters
    },
    model() {
      return this.tableState.model
    },
    columnGroup() {
      return this.tableState.columnGroup
    },
    firstRow() {
      if (this.rows) {
        for (let i = 0; i < this.rows.length; i++) {
          if (this.rows[i]) {
            return this.rows[i]
          }
        }
      }
      return null
    },
    summaryRow() {
      if (!this.meta || !this.meta.summary) {
        return null
      }
      const summaryRow = {}
      let hasSummaryData = false
      for (const column of this.flatColumns) {
        const summaryValue = getColumnValue(this.meta.summary, column.id)
        hasSummaryData = hasSummaryData || Boolean(summaryValue)
        summaryRow[column.id] = summaryValue
      }
      return hasSummaryData ? summaryRow : null
    },
    showSummaryRow() {
      return (
        this.rows &&
        this.rows.length > 0 &&
        this.summaryRow &&
        this.showSummaryGroups.includes(this.columnGroup)
      )
    },
    extraRows() {
      const { meta, rootGroup, extraRowsMessage } = this
      const extra = this.formatNumber(
        meta.total_filtered_results - rootGroup.lastRowIndex - 1
      )
      return extraRowsMessage.replace(':count', extra)
    }
  },
  watch: {
    /**
     * When the filter changes, reset the groups, and load the first page of data
     */
    filters() {
      this.rootGroup = null
      this.loadFirstRows()
    }
  },
  created() {
    this.DATATYPES = DATATYPES
  },
  mounted() {
    this.loadFirstRows()
    if (this.meta) {
      this.init()
    }
  },
  /**
   * Update the spacer height to match the row height
   * if at least one row of data has been rendered.
   */
  updated() {
    if (this.meta) {
      this.init()
    }
  },
  methods: {
    init() {
      const { tableHeader, tableSummary, testRow, table } = this.$refs

      // calculate the widths of each header, to prevent them shrinking when scrolling to unloaded rows
      const rows = table.getElementsByClassName('table-row')
      if (rows.length) {
        const cells = rows[0].children
        this.flatColumns.forEach((column, index) => {
          const existing = this.headerWidths[column.id] || 0
          this.headerWidths[column.id] = Math.max(
            existing,
            cells[index].getBoundingClientRect().width
          )
        })
      }

      if (testRow) {
        // Update dimensions of visible elements, and initialise the root row group
        this.spacerHeight = testRow.$el.getBoundingClientRect().height
        this.offsetHeight = tableHeader.getBoundingClientRect().height
        if (tableSummary) {
          this.offsetHeight += tableSummary.getBoundingClientRect().height
        }

        if (!this.rootGroup) {
          const { meta, spacerHeight: spacer, offsetHeight: offset } = this
          const rowCount = Math.min(this.maxRows, meta.total_filtered_results)
          this.rootGroup = new RowGroup(
            0,
            rowCount - 1,
            spacer,
            this.minGroupRows,
            offset
          )
          this.onScroll()
        }
      }
    },
    onScroll() {
      this.updateGroupVisibility()
      this.loadNewData_debounced()
    },
    loadNewData() {
      if (this.rootGroup) {
        const ranges = this.rootGroup.findMissingData(this.rows)
        if (ranges.length > 0) {
          ranges.forEach((range) => {
            const request = this.loadRows(range.from, range.to - range.from + 1)
            range.group.dataRequested = true

            if (request) {
              // if the request fails, mark it as needed re-fetching at next opportunity
              request.catch(() => {
                range.group.dataRequested = false
              })
            }
          })
        }
      }
    },
    updateGroupVisibility() {
      if (this.rootGroup) {
        const { container } = this.$refs
        const { scrollTop } = container
        const containerHeight = container.getBoundingClientRect().height
        this.rootGroup.updateVisibility(scrollTop, containerHeight)
      }
    },
    loadFirstRows(attempt = 1) {
      // try to load the first batch of rows, until it succeeds (or fails 10 times)
      return this.loadRows().catch(() => {
        if (attempt < 10) {
          return this.loadFirstRows(attempt + 1)
        } else {
          /** Failed to fetch row data from API */
          this.$emit('apierror', 'Failed to load initial rows')
        }
      })
    },
    loadRows(offset = 0, limit = 100) {
      // Check we don't already have the data for these rows
      let needsData = false
      for (let i = offset; i < offset + limit; i++) {
        if (!this.rows || !this.rows[i]) {
          needsData = true
          break
        }
      }
      if (needsData) {
        // Request the rows via the table store
        const request = this.tableStore.dispatch('loadRows', {
          offset,
          limit
        })

        if (request) {
          // emit an error if the request takes too long
          const alerter = setTimeout(() => {
            this.$emit('apierror', 'The request is taking longer than normal')
          }, this.slowRequestTimeout)

          return request
            .catch((err) => {
              const last = offset + limit - 1
              this.$emit(
                'apierror',
                `Failed to load rows ${offset} - ${last}: ${err.message}`
              )
              throw err
            })
            .finally(() => {
              clearTimeout(alerter)
            })
        }
      }
      return Promise.resolve()
    },
    cellType(columnDef, row) {
      const type = getMainType(columnDef.type)
      const value = getColumnValue(row, columnDef.id)

      if (type === DATATYPES.Disabled) {
        return 'sa-table-cell-disabled'
      }

      if (
        value === null ||
        typeof value === 'undefined' ||
        value.length === 0
      ) {
        return 'sa-table-cell-empty'
      }

      const renderer = this.getCustomRenderer(columnDef.id)
      if (renderer) {
        return renderer.cellType || 'sa-table-cell-simple'
      }

      switch (type) {
        case DATATYPES.ID:
          return 'sa-table-cell-id'
        case DATATYPES.Date:
          return 'sa-table-cell-date'
        case DATATYPES.Event:
        case DATATYPES.Status:
          // for event columns, just show the status
          return 'sa-table-cell-status'
        case DATATYPES.Statuses:
          return 'sa-table-cell-status-totals'
        default:
          return 'sa-table-cell-simple'
      }
    },
    cellProps(columnDef, row) {
      const type = getMainType(columnDef.type)
      const value = getColumnValue(row, columnDef.id)

      if (
        type === DATATYPES.Disabled ||
        value === null ||
        typeof value === 'undefined'
      ) {
        return { value: null }
      }

      const customProps = this.getCustomCellProps(columnDef.id, value, row)
      if (customProps !== null) {
        return customProps
      }

      const entityType = getSubType(columnDef.type)
      switch (type) {
        case DATATYPES.ID:
          return { entityType, id: value }
        case DATATYPES.Date:
          return { date: value }
        case DATATYPES.Event:
          return { status: value && value.status }
        case DATATYPES.Status:
          return { status: value }
        case DATATYPES.Statuses:
          return { statusTotals: value && value.statuses }
        case DATATYPES.Array:
          return { value: value.join(', ') }
        default:
          return { value }
      }
    },
    getCustomRenderer(id) {
      const renderer = this.customRenderers[id]
      if (typeof renderer === 'object') {
        return renderer
      }
      return null
    },
    getCustomCellProps(id, value, row) {
      const renderer = this.getCustomRenderer(id)
      if (renderer && typeof renderer.getProps === 'function') {
        return renderer.getProps(value, row)
      }
      return null
    }
  }
}

// Strip subtypes from a column type (e.g. 'ID<Sample>' => 'ID')
const getMainType = (type) => {
  return type ? type.split('<')[0] : null
}
// Get subtype from a column type (e.g. 'ID<Sample>' => 'Sample')
const getSubType = (type = '') => {
  const [, subType] = type.split('<')
  if (!subType) {
    return null
  }
  return subType.split('>')[0]
}
</script>
